import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

public class Firma{
    
    private String naziv;
    private HashMap<String, Projekat> projekti; //kljuc je sifra projekta
    private ArrayList<Zaposleni> zaposleni;  
    
    public Firma(String naziv){
        this.naziv=naziv;
        projekti=new HashMap<>();
        zaposleni=new ArrayList<>();
    }
    
    public void dodajZaposlenog(Zaposleni z){zaposleni.add(z);}
    public void dodajProjekat(Projekat p){projekti.put(p.dajSifru(), p);}
    
    // Tacka 11.
    public HashMap<String, Double> dnevnicaPoUlozi(){
        
        HashMap<String, Double> prosecneDnevnice = new HashMap<>();
        HashMap<String, Integer> frekvencijeUloga = new HashMap<>();
        
        for(Zaposleni z : zaposleni){
            String u = z.dajUlogu();
            Double d = prosecneDnevnice.get(u);
            if(d == null){
                prosecneDnevnice.put(u, z.dajDnevnicu());
                frekvencijeUloga.put(u, 1);
            } else {
                prosecneDnevnice.put(u, d + z.dajDnevnicu());
                frekvencijeUloga.put(u, 1 + frekvencijeUloga.get(u));
            }
        }
        
        for(String u : prosecneDnevnice.keySet()){
            prosecneDnevnice.put(
                u, 
                prosecneDnevnice.get(u) / frekvencijeUloga.get(u)
            );
        }
        
        return prosecneDnevnice;
    }
    
    // Tacka 12.
    public HashMap<String, HashSet<Pozicija>> pozicijePoZaposlenom(){
        HashMap<String, HashSet<Pozicija>> pozicije = new HashMap<>();
        for(Projekat pr : projekti.values()){
            for(Pozicija p : pr.pozicije().values()){
                // obrada pozicije
                for(Zaposleni z : p.angazovani()){
                    String ime = z.dajIme(); 
                    HashSet<Pozicija> pozicijeTekuceg = pozicije.get(ime);
                    if(pozicijeTekuceg == null){
                        pozicijeTekuceg = new HashSet<>();
                        pozicije.put(ime, pozicijeTekuceg);
                    }
                    pozicijeTekuceg.add(p);
                }
            }
        }
        return pozicije;
    }
    
    // tACKA 13.
    public static void  test(){
        Firma ep = new Firma("Energoprojekt AD"); // tacka a
        // Tacka b
        Projekat vila = new Projekat("Vila Ana", 100000);
        ep.dodajProjekat(vila);
        // Tacka c
        Zaposleni pera = new Zaposleni("Pera Peric", "Parketar", 40);
        Zaposleni mika = new Zaposleni("Mika Mikic", "Armirac", 30);
        ep.dodajZaposlenog(pera); ep.dodajZaposlenog(mika);
        // Tacka d
        Stub ps = new Stub("s1", 1, 30, 30, 240, 11.5);
        Parket pp = new Parket("p1", 1, 1, 10);
       // Dalje uradite sami ....
    }

}


