import java.util.HashSet;
import java.util.ArrayList;

public class Pozicija {
    private String sifra;
    private String opis;
    private double trajanje;
    protected double cena;
    private ArrayList<Zaposleni> angazovani;  
    
    public Pozicija(String sifra, double trajanje){
        this.sifra=sifra;
        this.trajanje = trajanje;
        cena = 0;
        angazovani=new ArrayList<>();
    }
    
    public String dajSifru(){return sifra;}
    
    // Tacka 6.
    public void odrediCenu(){
        // dopuniti 
        for(Zaposleni z : angazovani){
            cena += z.dajDnevnicu();
        }
        cena *= trajanje;
    }
    
    public void dodajZaposlenog(Zaposleni z){angazovani.add(z);}
    
    // Tacka 2.
    public String toString(){
        StringBuilder txt = new StringBuilder("   POZICIJA: sifra: " + sifra + ", trajanje: " + trajanje + ", cena: " + cena);
        for(Zaposleni z : angazovani) {
            txt.append("\n").append(z);
        }
        return txt.toString();
    }
    //Tacka 9.
    public double dajCenu(){return cena;}
    
    // Tacka 10.
    public HashSet<Zaposleni> zaposleniPoUlozi(String txt){
        HashSet<Zaposleni> pronadjeni = new HashSet<>();
        for(Zaposleni z : angazovani){
            if(z.dajUlogu().toLowerCase().contains(txt.toLowerCase())){
                pronadjeni.add(z);
            }
        }
        return pronadjeni;
    }
    
    // Tacka 12.
    public ArrayList<Zaposleni> angazovani() {return angazovani;}
}
